<?php
/**
 * @package SJ Zoo Slideshow II
 * @version 1.0
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @copyright (c) 2009-2011 YouTech Company. All Rights Reserved.
 * @author YouTech Company http://smartaddons.com
 *
 */

defined('_JEXEC') or die('Restricted access');

if (!class_exists('SjZooApplication') && class_exists('JFormField')){
	class JFormFieldSjZooApplication extends JFormField {
		public static $currentApplication = null;
		protected function getInput(){
			self::$currentApplication = $this->value;
			$db = &JFactory::getDbo();
			$query = "
				SELECT a.id, a.name as title, a.application_group
				FROM #__zoo_application a
				ORDER BY a.id
			";
			$db->setQuery($query);
			$applications = $db->loadObjectList();
			if (!$applications){
				if (file_exists(JPATH_ADMINISTRATOR .DS. 'components' .DS. 'com_zoo' .DS. 'config.php')){
					return JText::_('NO_ZOO_APPLICATION');
				} else {
					return JText::_('NO_ZOO_INSTALLED');
				}
			} else {
				$html = '<select class="inputbox" style="min-width: 200px;" id="' . $this->id . '" name="' . $this->name . '">';
				foreach ($applications as $app){
					$selected = ($app->id == $this->value) ? 'selected="selected"' : '';
					$html .= '<option value="' . $app->id . '" ' . $selected . '>' . $app->title . '</option>';
				}
				$html .= '<select>';
				return $html;
			}
		}
	}
}