<?php
/**
 * @package mod_sj_zoo_categories_ii
 * @version $Id$
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @copyright (c) 2009-2011 YouTech Company. All Rights Reserved.
 * @author YouTech Company
 *
 */

defined('_YTOOLS') or die;

if (!class_exists('ZooSlideShowIIReader')){
	class ZooSlideShowIIReader extends SjReader{
		// protected $categories = null;
		// protected $items = null;
		
		var $items = array();
		var $sec_cat_list = array();
		var $list_article = array();
		// var $frontpage = 0;
		var $featured = 0;	// 0 - without frontpage, 1 - only frontpage - 2 both
		var $type = 0;
		var $themes = array();
		var $category = array();
		var $articleid = array();
		var $limit = 5;
		var $listIDs = array();
		var $showtype = 1;
		var $theme = array();
		var $iditems = 0;
		var $article_ids = array();
		var $customUrl = array();      
		var $arrCustomUrl = array();
		var $is_cat_or_sec = 1;		
		// var $sort_order_field = 'created';
		var $type_order = 'DESC';	
		var $thumb_width = '40';
		var $thumb_height = '40';
		var $small_thumb_width = '0';
		var $small_thumb_height = '0';
		var $web_url = '';	
		var $cropresizeimage = 0;
		var $imagesource = 0;
		var $max_title = 0;
		//var $max_description = 0;
		var $max_main_description = 0;
		var $max_normal_description = 0;
		var $resize_folder = '';
		var $url_to_resize = '';
		var $url_to_module = '';	
		
		var $item_thumbnail_mode = 'none';
		
		public function __construct(){
			
		}
		
		public function getList(&$params){
			//old source 
			$params = (object)$params;
			
			if ( !isset($params->source) ){
				return JText::_('NO_SOURCE_SELECTED');
			} else if ( !is_array($params->source) ){
				$params->source = array($params->source);
			}
			
			$all_child_categories = $params->source;

			// $this->featured 				= $params->frontpage;
			$this->theme 					= $params->theme;
			$this->limit 					= $params->total;
			$this->customUrl 				= $params->customUrl;
			// $this->listIDs = $params->itemIds;
			$this->listIDs 					= '';
			// $this->sort_order_field 		= $params->sort_order_field;
			$this->thumb_height 			= $params->thumb_height;
			$this->thumb_width 				= $params->thumb_width;
			$this->max_main_description		= $params->limit_main_description;
			$this->max_normal_description	= $params->limit_normal_description;
			$this->small_thumb_height 		= $params->small_thumb_height;
			$this->small_thumb_width 		= $params->small_thumb_width;
			
			$this->web_url 					= JURI::base();
			$this->max_title        		= $params->limittitle;
			
			$this->item_thumbnail_mode 		= $params->item_thumbnail_mode;
			
			
			//end old source
		
            $items = array();
            $arrCustomUrl = $this->getArrURL();
            $db = & JFactory::getDBO ();
            $user = & JFactory::getUser ();
            $aid = $user->get ( 'aid', 1 );
            $aid = 1;
            $contentConfig = &JComponentHelper::getParams ( 'com_content' );
            $noauth = ! $contentConfig->get ( 'shownoauth' );
            jimport ( 'joomla.utilities.date' );
            $date = new JDate ( );
            $now = $date->toMySQL ();
            $nullDate = $db->getNullDate ();
            $where = $this->getCondition();
            $art_id = '';
            $catid= array();
            
			$arraycatid = $this->sec_cat_list;
            if (!is_null($params->source)){
				
				//query Zoo
				
				$zoo 		= &App::getInstance('zoo');
				
				// filter.
				if ( isset($params->source_filter) ){
					switch ( $params->source_filter ){
						default:
						case '0':
							$filter_cond = "";
						break;
						case '1':
							$filter_cond = "HAVING frontpage=0";
							break;
						case '2':
							$filter_cond = "HAVING frontpage=1";
							break;
					}
				}
				
				if ( isset($params->source_order_by) ){
					switch ( $params->source_order_by ){
						case 'random':
							$random_flag = true;
							$zoo_order_by = "rand()";
						default:
						case 'ordering':
							$zoo_order_by = "a.priority DESC";
						break;
						case 'hits':
							$zoo_order_by = "a.hits DESC";
							break;
						case 'created':
							$zoo_order_by = "a.created DESC";
							break;
						case 'modified':
							$zoo_order_by = "a.modified DESC";
							break;
						case 'title':
							$zoo_order_by = "a.name";
							break;
					}
				}
				
				
				
				$query = "
					SELECT
						a.*,
						COUNT(cm.id) as comments,
						DATEDIFF(NOW(), a.created) as datediff,
						 (SELECT COUNT(item_id) FROM #__zoo_category_item WHERE item_id = a.id AND category_id = 0) AS frontpage
					FROM #__zoo_item AS a
						INNER JOIN #__zoo_category_item AS ci ON ci.item_id=a.id AND ci.category_id IN (" . implode(",", $all_child_categories) . ")
						LEFT JOIN #__zoo_comment AS cm ON a.id=cm.item_id AND cm.state=1
					WHERE
						a.access IN (" . implode(",", $user->getAuthorisedViewLevels()) . ")
						AND a.state = 1
						AND ( a.publish_up = {$db->Quote($nullDate)} OR a.publish_up <= {$db->Quote($now)} )
						AND ( a.publish_down = {$db->Quote($nullDate)} OR a.publish_down >= {$db->Quote($now)} )
					GROUP BY a.id
					$filter_cond
					ORDER BY $zoo_order_by
					LIMIT 0 , $this->limit
				";
    				
				$db->setQuery ( $query );		
    			// $rows = $db->loadObjectList ();
				$rows = $db->loadObjectList('id', 'Item');
				
				
                $arrCustomUrl = $this->getArrURL();
    			
				$media_elements = $this->_parseValues($params->media_elements);
				$description_elements = $this->_parseValues($params->description_elements);
				
				$i=-1;
    			foreach($rows as $row) {
					$row->app = $zoo;
					$row->params = $zoo->parameter->create($row->params);
					$row->elements = $zoo->data->create($row->elements);
					
					$i++;
					$media_elements['_current'] = count($media_elements);
					$description_elements['_current'] = count($description_elements);

					foreach ($row->getElements() as $element){
						$element_class = get_class($element);
						$eclass_suffix = substr($element_class, 7);
						$eclass_suffix = strtolower($eclass_suffix);
						
						if ( array_key_exists($eclass_suffix, $media_elements) ){
							// image
							if ($media_elements[$eclass_suffix]<$media_elements['_current']){
								// $items[$i]['img'] = $element->hasValue('file') ? $element->get('file') : false;
								$items[$i]['img'] = $element->get('file');
								$media_elements['_current'] = $media_elements[$eclass_suffix];
							}
						} else if ( array_key_exists($eclass_suffix, $description_elements) ){
							// description
							if ($description_elements[$eclass_suffix]<$description_elements['_current']){
								$items[$i]['text'] = $element->get('value');
								// $items[$i]['content'] = $element->hasValue('value') ? $element->get('value') : '';
								$description_elements['_current'] = $description_elements[$eclass_suffix];
							}
						}
					}
					
					
    				$items[$i]['id'] = $row->id;

					if (! $items[$i]['img']){
						$ext_img	= YTools::extractImages($items[$i]['text']);
						if (!empty($ext_img)){
							$items[$i]['img']	= $ext_img[0];
						} else {
							$items[$i]['img']	= '';
						}
					}
					
					YTools::extractImages($items[$i]['text']);
					$items[$i]['content'] = $items[$i]['text'];
                    // $items[$i]['video'] = $this->getVideo($row->text);//var_dump($items[$i]['video']);die;
    				$items[$i]['title'] = $row->name;
					
    				
    				if(array_key_exists($row->id,$arrCustomUrl)){
                        $link = $arrCustomUrl[$row->id];
                    }else{
        				$link   = JRoute::_( 'index.php?option=com_zoo&task=item&item_id='. $row->id);;
        			}
    				$items[$i]['link'] = $link;
                }
				// // prepare for image resize.
				$imgResizeConfig = array(
					'background' => $params->item_thumbnail_background,
					'thumbnail_mode' => $params->item_thumbnail_mode
				);
				YtUtils::getImageResizerHelper($imgResizeConfig);
				
                $items = $this->update($items);
			
				/*   Process Images*/
			}
            
			return $items;
		}
		
		function getArrURL() {     

            $arrUrl = array();

            $tmp = explode("\n", trim($this->customUrl));            

            foreach( $tmp as $strTmp){
                $pos = strpos($strTmp, ":");
                if($pos >=0){
                    $tmpKey = substr($strTmp, 0, $pos);
                    $key = trim($tmpKey);
                    $tmpLink = substr($strTmp, $pos+1, strlen($strTmp)-$pos);

                    $haveHttp =  strpos(trim($tmpLink), "http://"); 
                    if(!$haveHttp && ($haveHttp!==0)){
                        $link = "http://" . trim($tmpLink);  
                    }else {
                        $link = trim($tmpLink);
                    }
                    $arrUrl[$key] = $link;
                }  
            }            
            return $arrUrl;
		}
		
		function getCondition() {	
			$sql = '';
			switch ($this->showtype) {
				case 0:
					if ($this->category == 0) {
						$sql = '';
					} else {
						$catids = !is_array($this->category) ? $this->category : '"'.implode('","',$this->category).'"';
						$sql = ' AND  a.catid IN( '.$catids.' )';
					}
					break;
				case 1:
					$ids = explode(',', $this->listIDs);	
					$tmp = array();				
					foreach( $ids as $id ){
						$tmp[] = (int) trim($id);
					}
					$sql = " AND a.id IN('". implode( "','", $tmp ) ."')";
					break;
				default:
					$sql = '';
			}
			return $sql;
		}
		
		function getSubCategories($pId, $clear = false) {
			static $cats = array();
			if ($clear == true) {
				 $cats = array();
			}
			$cats[] = $pId;
			$db = &JFactory::getDBO();
				$sql = 'SELECT c.id FROM #__categories c  WHERE c.parent_id = "'. $pId.'"';	
			$db->setQuery($sql);
			$items  = $db->loadObjectList();
			
			if (sizeof($items) > 0) {
				foreach($items as $item){
					$this->getSubCategories($item->id);
				}			
			}
			return $cats ;
		}
		
		function update($items) {		
			$tmp = array();
			
			foreach ($items as $key => $item) {
				if (!isset($item['sub_title'])) {
					$item['sub_title'] = YTools::truncate($item['title'], $this->max_title);
				}
				if (!isset($item['sub_main_content'])) {
					$item['sub_main_content'] = YTools::truncate($item['content'], $this->max_main_description);
				}
				if (!isset($item['sub_normal_content'])) {
					$item['sub_normal_content'] = YTools::truncate($item['content'], $this->max_normal_description);
				}
				
				//thumb image
				if ('none' == $this->item_thumbnail_mode){
					$item['thumb'] = empty($item['img']) ? 
											JURI::base().'modules/mod_sj_zoo_slideshowii/assets/images/nophoto.gif' : 
											$item['img'];
				} else {
					$item['thumb'] = empty($item['img']) ? 
											false :
											$item['img'];
					if (false != $item['thumb']){
						$imagefile 			= JPath::find(JPATH_SITE, $item['thumb']);
						$item['thumb'] 		= YtUtils::resize($imagefile, $this->thumb_width, $this->thumb_height, $this->item_thumbnail_mode);
					}
					
					if (! $item['thumb']){
						$item['thumb']	= JURI::base().'modules/mod_sj_zoo_slideshowii/assets/images/nophoto.gif';
					}
				}
				
				//small_thumb image
				if ('none' == $this->item_thumbnail_mode){
					$item['small_thumb'] = empty($item['img']) ? 
											// JURI::base().'modules/mod_sj_zoo_slideshowii/assets/images/nophoto.gif' : 
											'' :
											$item['img'];
				} else {
					$item['small_thumb'] = empty($item['img']) ? 
											false :
											$item['img'];
					if (false != $item['small_thumb']){
						$imagefile 			= JPath::find(JPATH_SITE, $item['small_thumb']);
						$item['small_thumb'] 	= YtUtils::resize($imagefile, $this->small_thumb_width, $this->small_thumb_height, $this->item_thumbnail_mode);
					}
					
					if (! $item['small_thumb']){
						// $item['small_thumb']	= JURI::base().'modules/mod_sj_zoo_slideshowii/assets/images/nophoto.gif';
						$item['small_thumb']	= '';
					}
				}
				
				
				//video
				// if (!isset($item['thumb_video']) && $item['video'] != '') {
					// $item['thumb_video'] = $this->processImage($item['video'], $this->thumb_width, $this->thumb_height, $item['id']);
					
				// } else {
					// $item['thumb_video'] = '';
				// }
				$tmp[] = $item;
			}
			
			return $tmp;				
		}
		
		private function _parseValues($paramString=null){
			$array = array();
			if ( isset($paramString) && is_string($paramString)){
				$keys = explode(',', $paramString);
				$keys = array_map('trim', $keys);
				$i=0;
				foreach ($keys as $key){
					$array[$key] = $i++;
				}
			}
			return $array;
		}
	}
}